function run_vot
%RUN_VOT ˴ʾйش˺ժҪ
%   ˴ʾϸ˵

% NSAMF tracker
% coded by Li, Yang, 2015


cleanup = onCleanup(@() exit() ); % Always call exit command at the end to terminate Matlab!
RandStream.setGlobalStream(RandStream('mt19937ar', 'Seed', sum(clock))); % Set random seed to a different value every time as required by the VOT rules.


[handle, image, region] = vot('rectangle'); % Obtain communication object

% firstImg = imread(image); % Read first image from file
% TODO: Initialize the tracker with first image and the given initialization region

target_sz = region([4,3]);
pos = region([2,1]) + floor(target_sz/2);
%% KCF
kernel.type = 'linear';
features.gray = false;
features.hog = false;

padding = 1.5;  %extra area surrounding the target
lambda = 1e-4;  %regularization
output_sigma_factor = 0.1;  %spatial bandwidth (proportional to target)

interp_factor = 0.02;

kernel.sigma = 0.5;

kernel.poly_a = 1;
kernel.poly_b = 9;

features.hog = true;
features.hog_orientations = 9;
cell_size = 4;
%%
[p,pos,~] = init([], [], pos, target_sz, 0);

im = imread(image);
if size(im,3) > 1,
    im = rgb2gray(im);
end
if p.resize_image,
    im = imresize(im, 0.5);
end
[p,~] = logupdate(1,im, pos, 1.0,p);
while true

    [handle, image] = handle.frame(handle); % Get the next frame

    if isempty(image) % Are we done?
        break;
    end;

    im = imread(image);
    if size(im,3) > 1,
        im = rgb2gray(im);
    end
    if p.resize_image,
        im = imresize(im, 0.5);
    end
 % Read the image from file
    % TODO: Perform a tracking step with the image, obtain new region
   
    [pos,tmp_sc] = tracking(im,pos,p);
    
    [p,box] = logupdate(0,im,pos, tmp_sc,p);

    region = box;
    
    handle = handle.report(handle, region); % Report position for the given frame

end;

handle.quit(handle); % Output the results and clear the resources





end



